#ifndef _NETLOAD_H_
#define _NETLOAD_H_

//#include "libs.h"
#include "types.h"
#include "color.h"
 
#include "video.h"
#include "lwip/ip_addr.h"


#define EVENT_INIT   0
#define EVENT_REDRAW 1
#define EVENT_BUTTON 2

void netload_drawMenu();
static void netload_conn_err(void *arg, err_t err);
static void netload_close_conn(struct tcp_pcb *pcb);
static err_t netload_poll(void *arg, struct tcp_pcb *pcb);
static err_t netload_sent(void *arg, struct tcp_pcb *pcb, u16_t len);
static err_t netload_recv(void *arg, struct tcp_pcb *pcb, struct pbuf *p, err_t err);
static err_t netload_accept(void *arg, struct tcp_pcb *pcb, err_t err);
void netload_A();
void netload_B();
void netload_X();
void netload_Y();
void netload_up();
void netload_down();





#endif
