/*
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */
#include <dvd.h>
#include <patcher.h>
#include <console.h>
#include <linux/string.h>
#include <pad.h>
#include <processor.h>
#include <cache.h>
#include <anaconda.h>

#include "lowmem.h"
#include "ipl.h"
#include "menu/menu.h"
#include "sram.h"
#include <setupdrive.h>
#include <patcher.h>
#include <dvdresetpatch/PATCH.H>
extern long GetMSR();
extern void SetMSR(long);
extern unsigned int dvd_readqoob(void* dst, int len, unsigned int offset);
typedef int my_dvd_read(void *, int, int);

void nothing()
{
}

void load_app()
{
	void (*app_init)(void (*report)(const char* fmt, ...));
	int (*app_main)(void** dst, int* size, int* offset);
	void* (*app_final)();

	void (*app_entry)(void(**init)(void (*report)(const char* fmt, ...)),
		int (**main)(), void *(**final)());

	char* buffer = (char*)0xC0100000;

	dvd_readqoob(buffer, 0x400, 0);

	SetMSR(GetMSR() & ~0x8000);
	SetMSR(GetMSR() | 0x2002);

	memset(buffer, 0, 0x20);
	dvd_readqoob(buffer, 0x20, 0x2440);

	dvd_readqoob((void*)0x81200000, ((*(unsigned long*)(buffer + 0x14)) + 31) & ~31, 0x2460);

	app_entry = (void (*)(void(**)(void (*)(const char*, ...)), int (**)(), void *(**)()))(*(unsigned long*)(buffer + 0x10));
	app_entry(&app_init, &app_main, &app_final);
	app_init((void (*)(const char*, ...))nothing);
	for (;;)
	{
		void* dst = 0;
		int len = 0,offset = 0;
		int res = app_main(&dst, &len, &offset);

		if (!res)
			break;
		dvd_readqoob(dst, len, offset);
		dvd_patchreset(dst,len);
		flush_code(dst, len);
	}
	memcpy((void*)0x80001800,patch,PATCH_LEN);
	void (*entrypoint)() = app_final();
	entrypoint();
}

