#ifndef __dvd_h
#define __dvd_h

unsigned int dvd_read(void* dst, int len, unsigned int offset);
unsigned int dvd_read_id();
void dvd_reset();
unsigned int dvd_init();
void dvd_motor_off();
void dvd_fix_streaming();
void dvd_set_audio(int enable, int len);
void dvd_set_streaming();
unsigned int dvd_get_error(void);
unsigned int dvd_get_diconfig(void);
void showBanner(int x, int y, int zoom);
int read_safe(void* dst, int len,int offset);
unsigned int dvd_read64(void* dst, int len, unsigned int offset);
const char* dvd_get_error_message(void);
unsigned char sector_buffer[2048] __attribute__((aligned(32)));
#endif
