
/* 	The Retail Game DVD Disk Header 
	Info source: YAGCD
	Size of Struct: 0x440	*/

typedef struct {
	u32 BNRMagicWord;	//Magic Word "BNR1" (US/JP) or "BNR2" (EU)
	u8  padding[0x1C];	//padding zeroes
	u8  BNRGFX[6144];	//Graphical Data (Pixel-format is RGB5A1)
	char shortName[32];	//Gamename (*)
	char shortDeve[32]; //Company/Developer (*)
	char fullName[64];	//Full Game Title (*)
	char fullDeve[64];	//Company/Developer Full name, or description (*)
	char Desc[128]; //Game Description (*)
	/*(*) All Text is all stored in either SHIFT-JIS or ASCII,
	 depending on the region of the Game.*/
		
} BANNER  __attribute__((aligned(32)));
BANNER TEMPBanner;

