#ifndef __sram_h
#define __sram_h
void sram_set_videomode(int v);
int sram_get_videomode(void);
void sram_set_autoboot(int v);
int sram_get_autoboot(void);
struct ip_addr *sram_get_ip(int w);
void sram_load_defaults(void);
void read_sram(void);
void write_sram(void);
int sram_get_value(int v);
void sram_set_value(int w, int v);
int ConfigTheSRAM(int btn);
void ConfigTheSound(int move);
u32 sram_rtc_bias();
void WriteLangValue(int what);
void sram_update_crcs();
int sram_get_patchcode(void);
void sram_set_patchcode(int v);
const char* autoDetect();
const char* patchSetting();
const char* curLang();
void sram_set_progressive();
#endif
