/*
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */
#ifndef _MENU_H_
#define _MENU_H_
unsigned int gcmlction[4];
//#include "libs.h"
#include "types.h"
#include "color.h"

#include "video.h"



#define EVENT_INIT   0
#define EVENT_REDRAW 1
#define EVENT_BUTTON 2

#define BUTTON_A 0
#define BUTTON_LEFT 1
#define BUTTON_RIGHT 2
#define BUTTON_UP 3
#define BUTTON_DOWN 4
#define BUTTON_B 5
void drawBG();
bool drivepatched;
void centre_redo();
struct menuentry_s; /* the menu stuff. */
void menu_cheats(struct menuentry_s* entry, int event, int data);
void menu_twodisccode(struct menuentry_s* entry, int event, int data);
void menu_set_sound(struct menuentry_s* entry, int event, int data);
void sram_card_test(struct menuentry_s* entry, int event, int data);
void mem_card_test(struct menuentry_s* entry, int event, int data);
void dvd_ms(struct menuentry_s* entry, int event, int data);
void menu_explore_qoob(struct menuentry_s* entry, int event, int data);
void menu_info(struct menuentry_s* entry, int event, int data);
void dvd_r(struct menuentry_s* entry, int event, int data);
void dump_firmware(struct menuentry_s* entry, int event, int data);
void dvd_rh(struct menuentry_s* entry, int event, int data);
void menu_help(struct menuentry_s* entry, int event, int data);//void menu_videomode(struct menuentry_s *entry, int event, int data);
void menu_backup(struct menuentry_s* entry, int event, int data);
void menu_boot_ipl(struct menuentry_s* entry, int event, int data);
void menu_save(struct menuentry_s* entry, int event, int data);
void menu_ip(struct menuentry_s* entry, int event, int data);
void menu_set_lang(struct menuentry_s* entry, int event, int data);
void menu_ip1(struct menuentry_s* entry, int event, int data);
void menu_boot_backup(struct menuentry_s* entry, int event, int data);
void menu_boot_game(struct menuentry_s* entry, int event, int data);
void menu_debug(struct menuentry_s* entry, int event, int data);
void menu_credits(struct menuentry_s* entry, int event, int data);
void menu_level(struct menuentry_s* entry, int event, int data);
void menu_autodetect(struct menuentry_s* entry, int event, int data);
void menu_gcosrls(struct menuentry_s* entry, int event, int data);
void menu_load_iso9660(struct menuentry_s* entry, int event, int data);
void menu_load_mp3(struct menuentry_s* entry, int event, int data);
void menu_soon(struct menuentry_s* entry, int event, int data);
void menu_redo();
void menuRefresh(void);

void ScrollBox(int iX, int iY, int iLines, int iStartLine, char* Text);



#endif
