#!/bin/sh

# Build Gamecube part
cd Gamecube/GCOSMultiGameDVD9
rm -f *.elf *.dol *.map load/loadapp.o *.binmake *.bin
make
A="$?"
if [ "$A" != 0 ]; then exit $A; fi
powerpc-gekko-objcopy -R .comment gcos.elf GCOSz.elf
powerpc-gekko-objcopy -O binary GCOSz.elf GCOS_NORM.bin
doltoolmod -c 2161115136 2161115136 GCOS_NORM.bin
d0lz GCOS_NORM.dol GCOS_DOLZ.dol -m
mv GCOS_NORM.dol GCOSz.elf GCOS_DOLZ.dol build
rm -f *.dol *.bin *.map *.elf

# Prep for the exe
mv build/GCOS_DOLZ.dol ../Pre-loader/include/dol.dol
cd ../Pre-loader/include
cmd /c convert.bat
cd ..
make
A="$?"
if [ "$A" != 0 ]; then exit $A; fi
cat gcm gcosproper.dol > working.gcm
mv working.gcm "../../PC/GCOS MultiGame Creator/gcm"
cd "../../PC/GCOS MultiGame Creator"
cmd /c convert.bat

echo +++ Compile PC/GCOS MultiGame Creator/main.c to build the EXE
